<app-loading *ngIf="isLoading"></app-loading>
<div class="container">
  <nz-card *ngIf="objFunctionSearch?.view" class="user-profile-card">
    <div nz-row class="user-profile-card__row">
      <div nz-col nzLg="21" nzSm="19" class="user-profile-card__left">
        <div style="position: relative">
          <mb-input-text
            [(ngModel)]="userParam.username"
            mbPlaceholderText="--{{ 'system.userProfile.label.user' | translate }}--"
            mbLabelText="{{ 'system.userProfile.label.user' | translate }}"
            (mbClick)="showListUserModal()"
            [mbReadOnly]="true"
          >
          </mb-input-text>
        </div>
      </div>
      <div nz-col nzLg="3" nzSm="5" class="user-profile-card__left__button-search">
        <mb-button mbButtonType="BORDER" mbButtonSize="VERY_LARGE" (click)="searchInfo()" class='btn'
                   mbButtonAvailableStyle="SEARCH" mbButtonText="{{'system.userProfile.label.search' | translate}}">
        </mb-button>
      </div>
    </div>
  </nz-card>

  <nz-card class="user-profile-card">
    <div style='margin-bottom: 1px'>
      <label class="title">{{ 'system.userProfile.label.infoUser' | translate }}</label>
    </div>
    <div nz-row [nzGutter]="[20,20]" class="info-user">
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.userName' | translate}}" mbLabelValue=" {{ infoUser?.username }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.email' | translate}}" mbLabelValue=" {{ infoUser?.email }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.location' | translate}}" mbLabelValue=" {{ infoUser?.posName }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.fullName' | translate}}" mbLabelValue=" {{ infoUser?.fullName }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.phoneNumber' | translate}}" mbLabelValue=" {{ infoUser?.phoneNumber }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.address' | translate}}" mbLabelValue=" {{ infoUser?.address }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.organization' | translate}}" mbLabelValue=" {{ infoUser?.orgName }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.dateOfBirth' | translate}}" mbLabelValue=" {{ infoUser?.dateOfBirth | date: 'dd/MM/yyyy' }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.gender' | translate}}" mbLabelValue=" {{ infoUser?.genderName }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.employeeCode' | translate}}" mbLabelValue=" {{ infoUser?.empCode }}"></mb-text-label>
      </div>
      <div  nz-col nzXs="24" nzSm='12' nzLg="6">
        <mb-text-label mbLabelText="{{'system.userProfile.label.title' | translate}}" mbLabelValue=" {{ infoUser?.jobName }}"></mb-text-label>
      </div>
    </div>
  </nz-card>
  <nz-card class="user-profile-card">
    <label class="title">{{ 'system.userProfile.label.infoPermission' | translate }}</label>
    <p *ngIf="!listFunctionPermission; else templateInfoPermission" class="warning">{{ 'system.userProfile.warning' | translate }}</p>
    <ng-template #templateInfoPermission>
      <nz-collapse>
        <nz-collapse-panel
          #p
          *ngFor="let panel of listFunctionPermission"
          [nzHeader]="header"
          [nzActive]="panel.active"
          [nzShowArrow]="true"
          (nzActiveChange)='activeChange(panel)'
          [nzExpandedIcon]="expandedIcon"
        >
          <ng-template #expandedIcon let-active>
            {{ active }}
<!--            <span nz-icon nzType="caret-right" class="ant-collapse-arrow" [nzRotate]="p.nzActive ? 90 : -90"></span>-->
            <div class='icon-panel'>
              <em class="fa fa-list-alt" aria-hidden="true"></em>
            </div>
          </ng-template>
          <ng-template #header>
            {{labelRole + panel.roleCode}} <span nz-icon nzType="caret-right" class="ant-collapse-arrow icon-panel-header" [nzRotate]="p.nzActive ? 90 : -90"></span>
          </ng-template>
          <div *ngIf='panel.active' nz-row class="user-profile-card__row">
            <div nz-col nzLg="14" nzSm='24' class="user-profile-card__left__role">
              <div class="user-profile-card__left__role__label">
                <span nz-typography class="user-profile-card__left__label">{{
                  'system.userProfile.label.featurePermission' | translate
                }}</span>
              </div>
              <nz-table class='data-table'
                #featurePermissionTable
                [nzOuterBordered]='true'
                [nzData]="panel.functionPermissionObjects"
                nzTableLayout="fixed"
                nzSize='small'
                [nzShowPagination]="false"
                [nzScroll]="panel.functionPermissionObjects.length > 7 ? { y: '290px' } : {}"
              >
                <thead>
                  <tr class='table-header'>
                    <th scope="col" nzWidth="60%">
                      {{ 'system.userProfile.table.label.name' | translate }}
                    </th>
                    <th scope="col" nzWidth="40%">
                      {{ 'system.userProfile.table.label.action' | translate }}
                    </th>
                  </tr>
                </thead>
                <tbody>
                  <ng-container *ngFor="let data of featurePermissionTable.data">
                    <ng-container *ngFor="let item of mapOfExpandedData[data.key]; trackBy: trackByNode">
                      <tr *ngIf="(item.parent && item.parent.expand) || !item.parent" class='row-table'>
                        <td
                          [nzIndentSize]="item.level! * 20"
                          [(nzExpand)]="item.expand"
                          (nzExpandChange)="collapse(mapOfExpandedData[data.key], item, $event)"
                        >
                          {{ item.name }}
                        </td>
                        <td>{{ item.scopes || [] | convertArrayString }}</td>
                      </tr>
                    </ng-container>
                  </ng-container>
                </tbody>
              </nz-table>
            </div>
            <div nz-col nzLg="10" nzSm='24' class="user-profile-card__left__data-permission">
              <div class="user-profile-card__left__role__label">
                <span nz-typography class="user-profile-card__left__label">{{
                  'system.userProfile.label.dataPermission' | translate
                }}</span>
              </div>
              <nz-table class='data-table'
                        #dataPermissionsTable
                        [nzData]="listDataPermissions[panel.key]"
                        nzTableLayout="fixed"
                        nzSize='small'
                        [nzShowPagination]="false"
                        [nzScroll]="{ y: '290px' }"
                        [nzOuterBordered]='true'
              >
                <thead>
                <tr class='table-header'>
                  <th scope="col">
                    {{ 'system.userProfile.table.label.data' | translate }}
                  </th>
                </tr>
                </thead>
                <tbody>
                <ng-container *ngFor="let data of dataPermissionsTable.data">
                  <ng-container *ngFor="let item of dataPermissions[panel.key][data.key]; trackBy: trackByNode">
                    <tr class="row-table" *ngIf="(item.parent && item.parent.expand) || item.parent == null">
                      <td [nzIndentSize]="item.level! * 20" [(nzExpand)]="item.expand"
                          (nzExpandChange)="collapsePermissions(dataPermissions[panel.key][data.key], item, $event)">
                        {{ item.name }}
                      </td>
                    </tr>
                  </ng-container>
                </ng-container>
                </tbody>
              </nz-table>
            </div>
          </div>
        </nz-collapse-panel>
      </nz-collapse>
    </ng-template>
  </nz-card>
</div>

